{
Copyright 2006 John T. Haller of PortableApps.com

Website: http://PortableApps.com/

This software is OSI Certified Open Source Software.
OSI Certified is a certification mark of the Open Source Initiative.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}

program PortableAppsMenu;

{%ToDo 'PortableAppsMenu.todo'}

uses
  Windows,
  Dialogs,
  Forms,
  Sysutils,
  main in 'main.pas' {frmMenu},
  about in 'about.pas' {frmAbout},
  add_app in 'add_app.pas' {frmAddApp},
  consts in 'consts.pas',
  CtgConfig in 'CtgConfig.pas' {dlgCtgConfig};

{$R *.RES}

var
  UniqueMessageID: Integer;

begin
  // Define our unique ID based on a long string and our path (we add the path so multiple launchers on multiple USBs still work)
  UniqueMessageID:=RegisterWindowMessage(PAnsiChar('IWishMyPortableAppsMenuWouldReappearOnA_NewInstanceCalled'+Application.ExeName));
  // Check for previous instance via exceedingly long mutex.
  CreateMutex(nil, false, PAnsiChar('DontChaWishYouHadAnExceedinglyLongMutexLikeMe_PortableAppsMenu'+IntToStr(UniqueMessageID)));
  if GetLastError = ERROR_ALREADY_EXISTS then
  begin
    // Tell our original window to reappear and quit our duplicate one
    SendMessage(HWND_BROADCAST, UniqueMessageID, 0, 0);
    Application.Terminate();
    exit;
  end;

  Application.Initialize;
  Application.Title := 'PortableApps Menu';
  Application.CreateForm(TfrmMenu, frmMenu);
  Application.CreateForm(TfrmAbout, frmAbout);
  Application.CreateForm(TfrmAddApp, frmAddApp);
  Application.CreateForm(TdlgCtgConfig, dlgCtgConfig);
  Application.Run;
end.

